/* $Id: foxio.h,v 1.1 2007/11/11 22:45:01 tat Exp $
 * KoanLogic - http://koanlogic.com */
#ifndef _KL_FOX_LINE_STAT_H_
#define _KL_FOX_LINE_STAT_H_
#include <sys/ioctl.h>
#include <fcntl.h>
#include <syslog.h>
#include "asm/etraxgpio.h"

/* use 1-80 array index for easy code to documentation mapping */
#define PIN_ARRAY_SIZE 81 
#define PIN_COUNT 80

/* N/A pin */
#define NA -1

/* port A */
#define IOA 0

/* port B */
#define IOB 1

/* port G */
#define IOG 2
#define OG  2
#define IG  2

/* line directions */
#define DIR_INPUT 0
#define DIR_OUTPUT 1

#define err_if(expr) if(expr) {                                              \
    syslog(LOG_ERR | LOG_USER, "[%s:%d] err: %s", __FILE__,__LINE__, #expr); \
    return 1; }

/* pin number (1-40 is FOX left connector J7 (top view),
 * 41-80 is the one on the right J6) */
typedef struct pin_s
{
    char port;      /* A, B or G                                            */
    int bit;        /* port{A,B,G} bit connected to this pin                */
    char *dsc;      /* line description                                     */
    int dir;        /* line direction (0: input, 1: output)                 */
    int value;      /* line 0/1 value                                       */
} pin_t;

int toggle_pin(int num);
int update_status(pin_t fox_pins[PIN_ARRAY_SIZE]);

#endif
