#include <sys/types.h>
#include <sys/stat.h>
#include <u/libu.h>
#include <fox/fpga.h>

int fpga_flash(const char *file)
{
    enum { BUFSZ = U_FILENAME_MAX + 128 };
    char cmd[BUFSZ];
    struct stat st;
    int rc;

    dbg_err_if(file == NULL);

    /* check that the file exists and that it's readable */
    dbg_err_sif(stat(file, &st) < 0);

    /* build the command string to run */
    dbg_err_if(u_snprintf(cmd, BUFSZ, "fpga_flash -aprogram -f%s", file));

    /* run the flash tool */
    rc = system(cmd);
    if(rc == -1 || rc == 127)
        dbg_err("error executing system()");

    /* assume that fpga_flash returns 0 when the flash process goes right,
       not zero otherwise */
    /* FIXME : is that true?*/

    return rc;
err:
    return ~0;
}
